#include "QD3DtoQTVR.h"
#include "extern.h"
#include "event.h"
#include "AEVT.h"

void EventLoop(void)
{	
	EventRecord		theEvent;
	RgnHandle		theMouseRgn;

	theMouseRgn = NewRgn();

	 while (! gQuit) {
		if (WaitNextEvent(everyEvent, &theEvent, 0L, theMouseRgn))
			DoEvent(&theEvent);
	}
	
	DisposeRgn(theMouseRgn);
}

void DoEvent(EventRecord *theEvent)
{	
	switch(theEvent->what) {
		case nullEvent:
			SendQuitApp();
			break;
		case mouseDown:
			break;
		case mouseUp:
			break;
		case keyDown:
		case autoKey:
			break;
		case activateEvt:
			break;
		case updateEvt:
			break;
		case osEvt:
			break;
		case kHighLevelEvent:
			DoHighLevelEvent(theEvent);
			break;
	}
}

